/*
 * Detect a Library for hardware detection
 *
 * Copyright (C) 2005 Alexandre Dussart
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "detect.h"
#include "utils.h"


struct keyboard_info *keyboard_detect(struct bus_lst *bus){
  struct keyboard_info *result = (struct keyboard_info *)NULL;
  static struct keyboard_info *first = (struct keyboard_info *)NULL;
  FILE *f;
  char *line;
  size_t len = 0;

/********************************************************************/
 /**************************AT Keyboard******************************/
 /*******************************************************************/
  if(debug){
    fprintf(stdout, "\nProbing AT keyboard devices...\n");
  }/*endif*/

  if((f = fopen("/proc/bus/input/devices", "r"))){
    while(getline(&line, &len, f) >= 0) {	
      if(!strncmp(line, "N: Name=", 8)){
	if((strstr(line, "keyboard")) || 
	   (strstr(line, "Keyboard"))) {
		if(!first){
       		 	first = result = (struct keyboard_info *)
                        my_malloc(sizeof(struct keyboard_info));
		} else {
		        result->next = (struct keyboard_info *)
                        my_malloc(sizeof(struct keyboard_info));
          	result = result->next;
        	}/*endif*/
	result->next = (struct keyboard_info *)NULL;         
	result->vendor = s_unknown;
	result->device = s_not_available;
	result->model = strdup(line + 9);
	strtok(result->model, "\"");
		if(debug){
   		fprintf(stdout, "\t\tFound %s %s\n", 
             		result->vendor, result->model);
   		}    
	}
    }
  }
  len = 0;
  free(line);
  fclose(f);
 }
 
  return first;
}
